// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FileServer.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package IcePatch2;

/**
 * The interface that provides access to files.
 * 
 **/
public interface FileServerPrx extends Ice.ObjectPrx
{
    /**
     * Return the {@link FileInfoSeq} for the specified partition. If the
     * partion number is out of range, the operation throws
     * {@link PartitionOutOfRangException}.
     * 
     * @param partition The partition number in the range 0-255.
     * 
     * @return A sequence containing the {@link FileInfo} structures for
     * files in the specified partition.
     * 
     **/
    public FileInfo[] getFileInfoSeq(int partition)
        throws PartitionOutOfRangeException;

    /**
     * Return the {@link FileInfoSeq} for the specified partition. If the
     * partion number is out of range, the operation throws
     * {@link PartitionOutOfRangException}.
     * 
     * @param partition The partition number in the range 0-255.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return A sequence containing the {@link FileInfo} structures for
     * files in the specified partition.
     * 
     **/
    public FileInfo[] getFileInfoSeq(int partition, java.util.Map<String, String> __ctx)
        throws PartitionOutOfRangeException;

    /**
     * Return the {@link FileInfoSeq} for the specified partition. If the
     * partion number is out of range, the operation throws
     * {@link PartitionOutOfRangException}.
     * 
     * @param partition The partition number in the range 0-255.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileInfoSeq(int partition);

    /**
     * Return the {@link FileInfoSeq} for the specified partition. If the
     * partion number is out of range, the operation throws
     * {@link PartitionOutOfRangException}.
     * 
     * @param partition The partition number in the range 0-255.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileInfoSeq(int partition, java.util.Map<String, String> __ctx);

    /**
     * Return the {@link FileInfoSeq} for the specified partition. If the
     * partion number is out of range, the operation throws
     * {@link PartitionOutOfRangException}.
     * 
     * @param partition The partition number in the range 0-255.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileInfoSeq(int partition, Ice.Callback __cb);

    /**
     * Return the {@link FileInfoSeq} for the specified partition. If the
     * partion number is out of range, the operation throws
     * {@link PartitionOutOfRangException}.
     * 
     * @param partition The partition number in the range 0-255.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileInfoSeq(int partition, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Return the {@link FileInfoSeq} for the specified partition. If the
     * partion number is out of range, the operation throws
     * {@link PartitionOutOfRangException}.
     * 
     * @param partition The partition number in the range 0-255.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileInfoSeq(int partition, Callback_FileServer_getFileInfoSeq __cb);

    /**
     * Return the {@link FileInfoSeq} for the specified partition. If the
     * partion number is out of range, the operation throws
     * {@link PartitionOutOfRangException}.
     * 
     * @param partition The partition number in the range 0-255.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileInfoSeq(int partition, java.util.Map<String, String> __ctx, Callback_FileServer_getFileInfoSeq __cb);

    /**
     * Return the {@link FileInfoSeq} for the specified partition. If the
     * partion number is out of range, the operation throws
     * {@link PartitionOutOfRangException}.
     * 
     * @param __result The asynchronous result object.
     * @return A sequence containing the {@link FileInfo} structures for
     * files in the specified partition.
     * 
     **/
    public FileInfo[] end_getFileInfoSeq(Ice.AsyncResult __result)
        throws PartitionOutOfRangeException;

    /**
     * Return the checksums for all partitions.
     * 
     * @return A sequence containing 256 checksums. Partitions with a
     * checksum that differs from the previous checksum for the same
     * partition contain updated files. Partitions with a checksum
     * that is identical to the previous checksum do not contain
     * updated files.
     * 
     **/
    public byte[][] getChecksumSeq();

    /**
     * Return the checksums for all partitions.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return A sequence containing 256 checksums. Partitions with a
     * checksum that differs from the previous checksum for the same
     * partition contain updated files. Partitions with a checksum
     * that is identical to the previous checksum do not contain
     * updated files.
     * 
     **/
    public byte[][] getChecksumSeq(java.util.Map<String, String> __ctx);

    /**
     * Return the checksums for all partitions.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksumSeq();

    /**
     * Return the checksums for all partitions.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksumSeq(java.util.Map<String, String> __ctx);

    /**
     * Return the checksums for all partitions.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksumSeq(Ice.Callback __cb);

    /**
     * Return the checksums for all partitions.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksumSeq(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Return the checksums for all partitions.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksumSeq(Callback_FileServer_getChecksumSeq __cb);

    /**
     * Return the checksums for all partitions.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksumSeq(java.util.Map<String, String> __ctx, Callback_FileServer_getChecksumSeq __cb);

    /**
     * Return the checksums for all partitions.
     * 
     * @param __result The asynchronous result object.
     * @return A sequence containing 256 checksums. Partitions with a
     * checksum that differs from the previous checksum for the same
     * partition contain updated files. Partitions with a checksum
     * that is identical to the previous checksum do not contain
     * updated files.
     * 
     **/
    public byte[][] end_getChecksumSeq(Ice.AsyncResult __result);

    /**
     * Return the master checksum for all partitions. If this checksum is the same
     * as for a previous run, the entire file set is up-to-date.
     * 
     * @return The master checksum for the file set.
     * 
     **/
    public byte[] getChecksum();

    /**
     * Return the master checksum for all partitions. If this checksum is the same
     * as for a previous run, the entire file set is up-to-date.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The master checksum for the file set.
     * 
     **/
    public byte[] getChecksum(java.util.Map<String, String> __ctx);

    /**
     * Return the master checksum for all partitions. If this checksum is the same
     * as for a previous run, the entire file set is up-to-date.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksum();

    /**
     * Return the master checksum for all partitions. If this checksum is the same
     * as for a previous run, the entire file set is up-to-date.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksum(java.util.Map<String, String> __ctx);

    /**
     * Return the master checksum for all partitions. If this checksum is the same
     * as for a previous run, the entire file set is up-to-date.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksum(Ice.Callback __cb);

    /**
     * Return the master checksum for all partitions. If this checksum is the same
     * as for a previous run, the entire file set is up-to-date.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksum(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Return the master checksum for all partitions. If this checksum is the same
     * as for a previous run, the entire file set is up-to-date.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksum(Callback_FileServer_getChecksum __cb);

    /**
     * Return the master checksum for all partitions. If this checksum is the same
     * as for a previous run, the entire file set is up-to-date.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getChecksum(java.util.Map<String, String> __ctx, Callback_FileServer_getChecksum __cb);

    /**
     * Return the master checksum for all partitions. If this checksum is the same
     * as for a previous run, the entire file set is up-to-date.
     * 
     * @param __result The asynchronous result object.
     * @return The master checksum for the file set.
     * 
     **/
    public byte[] end_getChecksum(Ice.AsyncResult __result);

    /**
     * Read the specified file. If the read operation fails, the
     * operation throws {@link FileAccessException}. This operation may only
     * return fewer bytes than requested in case there was an
     * end-of-file condition.
     * 
     * @param path The pathname (relative to the data directory) for
     * the file to be read.
     * 
     * @param pos The file offset at which to begin reading.
     * 
     * @param num The number of bytes to be read.
     * 
     * @return A sequence containing the compressed file contents.
     * 
     **/
    public byte[] getFileCompressed(String path, int pos, int num)
        throws FileAccessException;

    /**
     * Read the specified file. If the read operation fails, the
     * operation throws {@link FileAccessException}. This operation may only
     * return fewer bytes than requested in case there was an
     * end-of-file condition.
     * 
     * @param path The pathname (relative to the data directory) for
     * the file to be read.
     * 
     * @param pos The file offset at which to begin reading.
     * 
     * @param num The number of bytes to be read.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return A sequence containing the compressed file contents.
     * 
     **/
    public byte[] getFileCompressed(String path, int pos, int num, java.util.Map<String, String> __ctx)
        throws FileAccessException;

    /**
     * Read the specified file. If the read operation fails, the
     * operation throws {@link FileAccessException}. This operation may only
     * return fewer bytes than requested in case there was an
     * end-of-file condition.
     * 
     * @param path The pathname (relative to the data directory) for
     * the file to be read.
     * 
     * @param pos The file offset at which to begin reading.
     * 
     * @param num The number of bytes to be read.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileCompressed(String path, int pos, int num);

    /**
     * Read the specified file. If the read operation fails, the
     * operation throws {@link FileAccessException}. This operation may only
     * return fewer bytes than requested in case there was an
     * end-of-file condition.
     * 
     * @param path The pathname (relative to the data directory) for
     * the file to be read.
     * 
     * @param pos The file offset at which to begin reading.
     * 
     * @param num The number of bytes to be read.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileCompressed(String path, int pos, int num, java.util.Map<String, String> __ctx);

    /**
     * Read the specified file. If the read operation fails, the
     * operation throws {@link FileAccessException}. This operation may only
     * return fewer bytes than requested in case there was an
     * end-of-file condition.
     * 
     * @param path The pathname (relative to the data directory) for
     * the file to be read.
     * 
     * @param pos The file offset at which to begin reading.
     * 
     * @param num The number of bytes to be read.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileCompressed(String path, int pos, int num, Ice.Callback __cb);

    /**
     * Read the specified file. If the read operation fails, the
     * operation throws {@link FileAccessException}. This operation may only
     * return fewer bytes than requested in case there was an
     * end-of-file condition.
     * 
     * @param path The pathname (relative to the data directory) for
     * the file to be read.
     * 
     * @param pos The file offset at which to begin reading.
     * 
     * @param num The number of bytes to be read.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileCompressed(String path, int pos, int num, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Read the specified file. If the read operation fails, the
     * operation throws {@link FileAccessException}. This operation may only
     * return fewer bytes than requested in case there was an
     * end-of-file condition.
     * 
     * @param path The pathname (relative to the data directory) for
     * the file to be read.
     * 
     * @param pos The file offset at which to begin reading.
     * 
     * @param num The number of bytes to be read.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileCompressed(String path, int pos, int num, Callback_FileServer_getFileCompressed __cb);

    /**
     * Read the specified file. If the read operation fails, the
     * operation throws {@link FileAccessException}. This operation may only
     * return fewer bytes than requested in case there was an
     * end-of-file condition.
     * 
     * @param path The pathname (relative to the data directory) for
     * the file to be read.
     * 
     * @param pos The file offset at which to begin reading.
     * 
     * @param num The number of bytes to be read.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileCompressed(String path, int pos, int num, java.util.Map<String, String> __ctx, Callback_FileServer_getFileCompressed __cb);

    /**
     * Read the specified file. If the read operation fails, the
     * operation throws {@link FileAccessException}. This operation may only
     * return fewer bytes than requested in case there was an
     * end-of-file condition.
     * 
     * @param __result The asynchronous result object.
     * @return A sequence containing the compressed file contents.
     * 
     **/
    public byte[] end_getFileCompressed(Ice.AsyncResult __result)
        throws FileAccessException;
}
