// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FileServer.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package IcePatch2;

/**
 * The interface that provides access to files.
 * 
 **/
public interface _FileServerOperationsNC
{
    /**
     * Return the {@link FileInfoSeq} for the specified partition. If the
     * partion number is out of range, the operation throws
     * {@link PartitionOutOfRangException}.
     * 
     * @param partition The partition number in the range 0-255.
     * 
     * @return A sequence containing the {@link FileInfo} structures for
     * files in the specified partition.
     * 
     **/
    FileInfo[] getFileInfoSeq(int partition)
        throws PartitionOutOfRangeException;

    /**
     * Return the checksums for all partitions.
     * 
     * @return A sequence containing 256 checksums. Partitions with a
     * checksum that differs from the previous checksum for the same
     * partition contain updated files. Partitions with a checksum
     * that is identical to the previous checksum do not contain
     * updated files.
     * 
     **/
    byte[][] getChecksumSeq();

    /**
     * Return the master checksum for all partitions. If this checksum is the same
     * as for a previous run, the entire file set is up-to-date.
     * 
     * @return The master checksum for the file set.
     * 
     **/
    byte[] getChecksum();

    /**
     * Read the specified file. If the read operation fails, the
     * operation throws {@link FileAccessException}. This operation may only
     * return fewer bytes than requested in case there was an
     * end-of-file condition.
     * 
     * @param __cb The callback object for the operation.
     * @param path The pathname (relative to the data directory) for
     * the file to be read.
     * 
     * @param pos The file offset at which to begin reading.
     * 
     * @param num The number of bytes to be read.
     * 
     **/
    void getFileCompressed_async(AMD_FileServer_getFileCompressed __cb, String path, int pos, int num)
        throws FileAccessException;
}
